#include <stdio.h>
#include <ctype.h>
#include <string.h>

using namespace std;

FILE *fichero;
char *MATRIZ_FECHAS[30];
char nueva_fecha[]="fechafechafech";
int contador_de_fechas_distintas=0;

void AbrirFichero();
void VisualizarImagenDeFichero();
void CerrarFichero();
void VisualizarSoloLasFechas();
void Guardar_En_MATRIZ_FECHAS(char nueva_fecha[],int numero_registro);
void Visualizar_MATRIZ_FECHAS(int cantidad_de_registros);

int main()
{
    AbrirFichero();
    // Imprime por pantalla una imagen del fichero
    VisualizarImagenDeFichero();
    CerrarFichero();
    AbrirFichero();
    // Imprime por pantalla las fechas existentes en fichero
    VisualizarSoloLasFechas();
    CerrarFichero();
    // Deberia imprimir las fechas guardadas anteriormente en la matriz
    // pero solo imprime la última fecha en todos los registros de la matriz
    Visualizar_MATRIZ_FECHAS(contador_de_fechas_distintas);
    return 0;
}

void AbrirFichero()
{

    if ((fichero=fopen("fichero_a_tratar.dat","a+"))==NULL)
    {
        printf("Error: no se pudo abrir en fichero");
    }
}
void CerrarFichero()
{
    fclose(fichero);
}
void VisualizarImagenDeFichero()
{
    printf("\n=============== Impresion de imagen de fichero  =========\n");
    while(!feof(fichero))
    {
        fputc(fgetc(fichero), stdout);
    }
}
void VisualizarSoloLasFechas()
{
    printf("\n=============== Impresion de las fechas del fichero  =========\n");
    char caracter_leido;
    int contador_posicion_nueva_fecha=0;
    bool es_el_inicio_de_una_fecha=false;
    while (!feof(fichero))
    {
        caracter_leido=fgetc(fichero);

        if (caracter_leido=='<')
        {
            es_el_inicio_de_una_fecha=true;
        }
        if (es_el_inicio_de_una_fecha)
        {


            if (contador_posicion_nueva_fecha>=2 && contador_posicion_nueva_fecha<=15)
            {

                nueva_fecha[contador_posicion_nueva_fecha-2]=caracter_leido;
            }
            contador_posicion_nueva_fecha++;
        }
        if (caracter_leido=='>')
        {
            // Guarda la nueva fecha en la matriz
            Guardar_En_MATRIZ_FECHAS(nueva_fecha,contador_de_fechas_distintas);
            contador_posicion_nueva_fecha=0;
            contador_de_fechas_distintas++;
            printf("\n%s",nueva_fecha);
            es_el_inicio_de_una_fecha=false;
        }

    }

}
void Guardar_En_MATRIZ_FECHAS(char fecha[],int numero_registro)
{
    MATRIZ_FECHAS[numero_registro]=fecha;

}
void Visualizar_MATRIZ_FECHAS(int cantidad_de_registros)
{
    printf("\n=============== Impresion del volcado del Array  =========\n");
    printf("=========== el cual deberia mostrar fechas distintas =====\n");
    for (int k=0; k<cantidad_de_registros; k++)
    {
        if (MATRIZ_FECHAS[k]!=NULL)
        {
            printf("\nValor de MATRIZ_FECHAS[%d] = %s",k,MATRIZ_FECHAS[k]);

        }
        else
        {
            printf("\nFin de la visualización");
            k=cantidad_de_registros;
        }
    }

}
